      program compress
*This is a data compression program - P Banks 15/5/89
*It will do 2 passes. First pass will assemble a table of most
* frequently used characters.Second pass will examine file byte by byte
* and output to new file in the following way:-
*3 bits will indicate how many bits are to be used for character.e.g 
*most frequent character will be encoded as 0, second most as 1 etc.
*therefore 000 0        - most common character
*          000 1        - second most common
*          010 111      - eighth most common
*          011 1000     - ninth most common
*          011 1111     - sixteenth
*          100 10000    - seventeenth
*          101 100000   - thirtythird
*          110 1000000  - sixty-fifth
*          111 10000000 - 129th
*          111 11111111 - 256th 
* N.B. 1st is logged as 0 etc, and the 3 bits are displaced by one, i.e.
*      000 indicates 1 bit, 111 indicates 8 etc.
      common freq,fname,instring,stat
      real freq(255),stat(9)
      character*12 fname
      character*1024 instring
      call first
      call sort
   79 continue
      stop
      end
************************************************************************
      subroutine first
      common freq,fname,instring,stat
      real freq(255),stat(9)
      character*12 fname,bin*7,form*7
      character*1024 instring
      write(*,*)' Input filename'
      read(*,90)fname
      write(*,*)fname
      inquire(file=fname,binary=bin,formatted=form)
      if(bin.eq.'YES')goto 10
      if(form.eq.'YES')goto 15
   10 open (1,BLOCKSIZE=1024,err=80,file=fname,form='BINARY',iostat=ioc
     1heck,mode='READ',recl=1024,share='DENYRD',status='OLD')
      goto 20
   15 open (1,BLOCKSIZE=1024,err=80,file=fname,form='FORMATTED',
     1iostat=iocheck,mode='READ',recl=1024,share='DENYRD',status='OLD')
   20 read(1,end=81,err=82,iostat=iocheck)instring
      call out
      pause
      return
*error routine
   80 write(*,*)' ERROR !! opening file - error code ',iocheck
      stop
   81 write(*,*)' End of file on read'
      call out
      pause
      return
   82 write(*,*)' ERROR !! reading file - error code ',iocheck
      stop  
   90 format(a)
      end
************************************************************
      subroutine out
      common freq,fname,instring,stat
      real freq(256),stat(9)
      character*12 fname
      character*1024 instring
      integer*2 i
      do 20 i=1,len(instring)
       i2=ichar(instring(i:i))+1
       freq(i2)=freq(i2)+1
       write(*,90)i2
   20 continue
      return
   90 format(1x,i3\)
      end
*****************************************************************
      subroutine sort
      common freq,fname,instring,stat
      real freq(256),stat(9)
      character*12 fname
      character*1024 instring
      integer*2 i,i2
      do 20 i=1,255
         do 19 i2=i+1,256
            if (freq(i).ge.freq(i2))goto 19
            item=freq(i)
            freq(i)=freq(i2)
            freq(i2)=item
   19   continue
   20 continue
      call stats
      return
      end
**************************************************************    
      subroutine stats
      common freq,fname,instring,stat
      real freq(256),stat(9),saving(9)
      character*12 fname
      character*1024 instring
      do 10 i=1,2
   10 stat(1)=stat(1)+freq(i)
      saving(1)=stat(1)*4
      do 11 i=3,4
   11 stat(2)=stat(2)+freq(i)
      saving(2)=stat(2)*3
      do 12 i=5,8
   12 stat(3)=stat(3)+freq(i)
      saving(3)=stat(3)*2
      do 13 i=9,16
   13 stat(4)=stat(4)+freq(i)
      saving(4)=stat(4)*1
      do 14 i=17,32
   14 stat(5)=stat(5)+freq(i)
      saving(5)=stat(5)*0
      do 15 i=33,64
   15 stat(6)=stat(6)+freq(i)
      saving(6)=stat(6)*(-1)
      do 16 i=65,128
   16 stat(7)=stat(7)+freq(i)
      saving(7)=stat(7)*(-2)
      do 17 i=129,256
   17 stat(8)=stat(8)+freq(i)
      saving(8)=stat(8)*(-3)
      do 18 i=1,8
      saving(9)=saving(9)+saving(i)
   18 stat(9)=stat(9)+stat(i)
      write(*,90)' 4-bits ',8*stat(1),' -saving=',saving(1)
      write(*,90)' 5-bits ',8*stat(2),' -saving=',saving(2)
      write(*,90)' 6-bits ',8*stat(3),' -saving=',saving(3)
      write(*,90)' 7-bits ',8*stat(4),' -saving=',saving(4)
      write(*,90)' 8-bits ',8*stat(5),' -saving=',saving(5)
      write(*,90)' 9-bits ',8*stat(6),' -saving=',saving(6)
      write(*,90)' 10-bits ',8*stat(7),' -saving=',saving(7)
      write(*,90)' 11-bits ',8*stat(8),' -saving=',saving(8)
      write(*,*)' total = ',8*stat(9),' - saving=',saving(9),' bits'
      write(*,*)'percentage saving=',(saving(9)*100)/(8*stat(9))
   90 format(1x,a,f30.0,a,f30.0)
      return
      end
************************************************
      
      